/*
   html.c - html parser
   Copyright (c) 1999  Martin Hinner <martin@tdp.cz>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>

#define MAXTAGSIZE 1024

char *gettagparam(char *dest,char *tag,int maxlen)
{
	char *odest = dest;
	
	while ( (*tag) && (*tag!='=') )
	{
		*dest=*tag;
		tag++;
		dest++;
		maxlen--;
		if (!maxlen)
			return odest;
	}
	*dest = 0;
	return odest;
}

char *gettagvalue(char *dest,char *tag,int maxlen)
{
  char *odest = dest;

  while ( (*tag) && (*tag!='=') )
    tag++;
	*dest = 0;
	if (!*tag)
		return 0;
	
  return odest;
}


int parsehtml(int handle,int (puttag)(char *tag),int (processchar)(char ch))
{
 char *tag;
 char c;
 int istag,taglen;
 
 tag = (char *)malloc(MAXTAGSIZE+1);
 
 taglen = 0;
 istag = 0;

 while (read(handle,&c,1)==1)
 {
	 if (c=='<')
	 {
		 istag=1;
		 continue;
	 }
	 
	 if (!istag)
	 	 if (processchar)
		   processchar(c);
	 
	 if (istag)
	 {
		if ( (taglen>=MAXTAGSIZE) || (c=='>') )
		{
			istag = 0;
			tag[taglen]=0;
			if (puttag)
				puttag(tag);
			taglen = 0;
		}else
			tag[taglen++] = c;
		continue;
	 }
 }
}

char *htmlgettoken()
{

}

int parsehtmltag(char *tag,char **argv,int max)
{
 int argc;
 int isquot;
 char *p;

 argc=0;

 while (*tag) {
   /* New arg... */
   while (isspace(*tag))
    tag++;
   if (argc+1>=max)
     return argc;
   /*printf("HTML:tag(%u)=%s\n",argc,tag);*/
   argv[argc++] = tag;
   while (!isspace(*tag) && (*tag!='=') && (*tag) )
    tag++;
   if (!*tag)
    return argc;
   /* Look for value */
   p = tag;
   while (isspace(*p)) p++;
   if (*p=='=') {
      isquot=0;
      p++;
      /*printf("HTML:have arg:%s\n",p);*/
      *tag++ = '=';
      while (isspace(*p) && (*p) )
       p++;
      if (!*p) {
       *tag=0;
       return argc;
      }

      while ( (*p) ) {
       if (!isquot)
        if (isspace(*p))
         break;
       if (*p == '\"')
        isquot = isquot?0:1;
       else
        if (*p!='\n')
         *tag++=*p;
       p++;
      }
    *tag = 0;
    tag = p;
   }else
   *tag++=0;

  }

 return argc;
}

char *htmlgetparam(int argc,char **argv,char *param)
{
 int n;

 for (n=1;n<argc;n++)
  if (!strncasecmp(argv[n],param,strlen(param)))
   if (argv[n][strlen(param)]=='=')
    return argv[n]+strlen(param)+1;
 return 0;
}
